#ifndef __DlgFindParams__
#define __DlgFindParams__

#include "..\Includes\cDlg.h"


//
//	Class String List for recent strings to be found.
//
class cStrListItem;

class cStrList
{
public:

	cStrListItem *m_head;

	cStrList()
	{
		memset( this, 0, sizeof( *this ) );
	}

	~cStrList();

	bool Add( wchar_t *ws, int len );
	cStrListItem *Find( wchar_t *ws, int len );
	bool Remove( cStrListItem *l );
};

class cFindParams
{
	cStrList m_recentList;
public:
	enum { eMatchCase = 1, eSearchUp = 2 };

	bool m_bSearchUp;
	bool m_bMatchCase;
	wchar_t *m_wString;

	bool RegSave();
	bool RegGet();

	cFindParams();
	~cFindParams();

	bool IsEmpty();

	HWND m_hListView;
	int m_columnQ;

	//
	//	GetCurSel
	//		Get current selection and checks bounds for sear direction
	//
	int GetCurSel( int *pCount = NULL );

	//
	//	Add 
	//		1. adds specified string to recent list
	//		2. updates m_walkCout
	//		3. refreshs combo box if hCmb is specified.
	//
	bool Add( wchar_t *ws, int len, HWND hCmb = NULL );

	//
	//	m_walkCout - is used for loop notification.
	//		It assigned by 
	//			1. m_recentList changing
	//			2. m_bSearchUp  changing
	//			3. m_bMatchCase changing
	//			4. Loop notification ( see fnLoop in FindNext )
	//			5. Or by FindNext if it was not inited yet
	//
	int m_walkCout; 
	//
	//	FindNext
	//		Finds combobox top recent string from current position in list view.
	//		Returns one of following enums
	//	
	enum { fnFound = 0, fnError, fnNotFound, fnLoop };
	int FindNext();
	bool FindNext( HWND hWnd );
};

class cDlgFindParams : public cDlg
{
	 cFindParams *m_params;
public:
	cDlgFindParams( cFindParams *params );
	LRESULT RealDlgProc( UINT uMsg, WPARAM wParam, LPARAM lParam );
	BOOL OnFindNext();
};

#endif // __DlgFindParams__