#ifndef __DlgCreateCertificate__
#define __DlgCreateCertificate__

#include <windows.h>
#include "..\certificateLib\x509pkts\x509_structs.h"
#include "..\BCZip\Frame\Dialog.h"
#include "resource.h"

class cDlgCreateCertificate : public cDlg
{
//	x509_certificate m_cer;
	
	int m_version;		// 2 ( means v3 )
	int m_serialNumber;	// current value get from storage for assigned issuer
	BYTE m_hashAlgID;
	sNameAttributeList	
		m_rdnSubject,
		m_rdnIssier;

	// Validity
	int m_nbYe, m_nbMo, m_nbDa; // Not before Year, Month, Day
	int m_naYe, m_naMo, m_naDa; // Not after Year, Month, Day

	bool m_bCA; // BasicConstraints CertificateAuthority

  public:

	HWND m_hLView;
	HPKA *m_pSka, *m_pPka;

	enum { ID = IDD_CreateCertificate };

	cDlgCreateCertificate( HPKA *pPka, HPKA *pSka )
	{
		m_pSka = pSka;
		m_pPka = pPka;
	}

 private:

	BOOL RealDlgProc( UINT uMsg, WPARAM wParam, LPARAM lParam );
	BOOL InitDialog();

	enum {
		lvId_first = 0,
		lvId_version = lvId_first,
		lvId_serialNumber,
		lvId_signatureAlgorithm,
		lvId_issuerRdn,
		lvId_validFrom,
		lvId_validTo,
		lvId_subjectRdn,
		lvId_publicKey,
		lvId_subjectKeyID,
		lvId_authrityKeyID,
		lvId_basicConstraints,
		lvId_last = lvId_basicConstraints
	};

	bool UpdateFields( bool editableOnly = true ); // Does not update static fields
};

bool GetRDN( HINSTANCE hInst, HWND hWnd, sNameAttributeList *rdn, const char *caption );

#endif // __DlgCreateCertificate__