#pragma once

#include "resource.h"

#include "..\Includes\cDlg.h"

#include "..\CertificateLib\x509pkts\x509_structs.h"
#include "..\CertificateLib\SMemory\SMemory.h"

//
//	1. InitDialogue calls RSA primes generation thread 
//	2. Waits notification if generarion finishes, as result m_hSka is generated
//	3. Processes the generation progress block actor feedback messages ( see cProgressObj ).
//
class cDlgPrimesGen : public cDlg
{
	cSizedCtrls sizedCtrls;

public:
	// Additional random buffer may be required
	static int m_additionalRndSizeRequired;
	static void *m_ptbAdditionalRnd;
//	static cPlainTextBlock *m_ptbAdditionalRnd;

	enum { IDD = IDD_DlgPrimeGeneration };

	HPKA m_hSka;
	HANDLE m_thread;
	bool m_cancelled;
	bool m_useSafePrime;
	int m_keyBitSize;

	cDlgPrimesGen( int keyBitSize, bool useSafePrime )
	{
		m_thread = NULL;
		m_cancelled = false;
		m_hSka = NULL;
		m_useSafePrime = useSafePrime;
		m_keyBitSize = keyBitSize;
	}

	~cDlgPrimesGen();

	LRESULT RealDlgProc( UINT uMsg, WPARAM wParam, LPARAM lParam );
	BOOL InitDialog();

	DWORD m_timeStart;
	DWORD m_timerID;
	static void CALLBACK SetTimeValue( HWND hwnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime );
	void InitTimer();
};

int GenerateSeed( HINSTANCE hInst, HWND hParent, BYTE *seedBuff, int seedSize );
