#pragma once

#include <windows.h>
#include <string.h>
#include <assert.h>
#include <stdio.h>

class CDll
{
public:

	HINSTANCE hInst;

	enum { errNo = 0, errInit, errGetProcAddress };

	int error;
	void *pProc;

	bool m_showMessage;

	static int ErrorOut( const char *err, const char *name, const char *caption = "Error", int id = MB_ICONSTOP );

	// virtual 
	bool Load( BOOL usePath , const wchar_t *libraryName, const char *procName = NULL, BOOL showMessage = TRUE );
	bool Load( BOOL usePath , const char *lpLibFileName, const char *procName = NULL, BOOL showMessage = TRUE );
	bool LoadOnce( BOOL usePath , const char *libraryName,/* const char *procName = NULL,*/ BOOL showMessage = TRUE );
	bool LoadProcOnce( BOOL usePath , const wchar_t *libraryName, const char *procName, BOOL showMessage = TRUE );
	bool LoadProcOnce( BOOL usePath , const char *libraryName, const char *procName, BOOL showMessage = TRUE );

	CDll( BOOL usePath , const wchar_t *libraryName, const char *procName = NULL, BOOL showMessage = TRUE );
	CDll( BOOL usePath , const char *libraryName, const char *procName = NULL, BOOL showMessage = TRUE );
	CDll();
	~CDll();

	void Unload();

	//virtual 
		BOOL GetProcAddress( const char *procName, BOOL showMessage = TRUE, void **ppProc = NULL );
	void *GetProcAddressEx( const char *procName );
	
	//
	//	If a dll is statically loaded and transation is changed the dll translation may be changed by the function.
	//
	bool UpdateModuleTranslation();

	wchar_t m_path[ MAX_PATH ];
};

//extern "C"
//{
//	typedef int __stdcall typeProcStr( const wchar_t *str );
//};