#include "IconFuncs.h"
#include "UnicodeFuncs.h"
#include "ODS.h"


//HBITMAP IconToBitmap( HICON hIcon )
//{
//	int cx = 16;
//	int cy = 16;
//	//cx = GetSystemMetrics(SM_CXICON);
//	//cy = GetSystemMetrics(SM_CYICON);
//
//	GetMenuBitmapFromIcon(
//	CreateDIB
//
//	HDC hDC = CreateCompatibleDC( NULL );
//	HBITMAP hBitmap = CreateCompatibleBitmap( hDC, cx, cy );
//	HBITMAP hOldBitmap = (HBITMAP )SelectObject( hDC, hBitmap );
//	DrawIcon( hDC, 0, 0, hIcon );
//	SelectObject( hDC, hOldBitmap );
//	DeleteDC( hDC );
//	return hBitmap;
//}

HBITMAP CreateDIB( LONG width, LONG height, BYTE** bitmapBits ) 
{ 
	BITMAPINFO info; 
	ZeroMemory(&info, sizeof(info)); 
	info.bmiHeader.biSize = sizeof(BITMAPINFOHEADER); 
	info.bmiHeader.biWidth = width; 
	info.bmiHeader.biHeight = height; 
	info.bmiHeader.biPlanes = 1; 
	info.bmiHeader.biBitCount = 32; 

	HDC screenDC = GetDC(NULL); 
	HBITMAP hBmp = CreateDIBSection(screenDC, &info, DIB_RGB_COLORS, reinterpret_cast<void**>(bitmapBits), NULL, 0); 
	if ( hBmp == NULL )
	{
		ODSF( L"CreateDIB error %d", GetLastError() );
	}

	return hBmp;
} 

HBITMAP IconToBitmap( HICON hIcon, bool bDestroyIcon )
{
	//ODSFunc;

	BITMAP bitmap; 
	ICONINFO iconInfo; 
	ZeroMemory(&bitmap, sizeof(bitmap)); 
	ZeroMemory(&iconInfo, sizeof(iconInfo)); 

	//Try to get the icon's size, bitmap and bit depth. We will try to convert 
	//the bitmap into a DIB for display on Vista if it contains an alpha channel. 
	if ( !GetIconInfo( hIcon, &iconInfo ) ) 
	{
		ODS( L"GetIconInfo return error" );
		return NULL; 
	}

	HBITMAP iconMask = iconInfo.hbmMask; 

	if (!GetObject(iconInfo.hbmColor, sizeof(BITMAP), &bitmap) || 
		bitmap.bmBitsPixel < 32) 
	{
		ODSF( L"bitmap.bmBitsPixel %d", bitmap.bmBitsPixel );
		if ( bDestroyIcon )	DestroyIcon( hIcon );
		return iconInfo.hbmColor; 
	}

	//Draw the icon onto the DIB which will preseve its alpha values 
	HDC hdcDest = CreateCompatibleDC(NULL);
	BYTE *pMap;
	HBITMAP dib = CreateDIB( bitmap.bmWidth, bitmap.bmHeight, &pMap ); 
	//ODSF( L"CreateDIB %X", dib );
	SelectObject( hdcDest, dib ); 

	HBITMAP iconBitmap = iconInfo.hbmColor; 
	BOOL ok = DrawIconEx( hdcDest, 0, 0, hIcon, bitmap.bmWidth, bitmap.bmHeight, 0, NULL, DI_NORMAL ); 
	//ODSF( L"DrawIconEx %s", getWCStr( ok == TRUE ) );

	DeleteDC( hdcDest );

	if ( bDestroyIcon )	DestroyIcon( hIcon );

	return dib; 
} 


HBITMAP GetBitmapFromFile( const wchar_t *path, int iconNum )
{
	//ODSFuncS( cWCStr().FormatT( L"%s, %d", path, iconNum ) );

	HICON hIconLarge;
	HICON hIconSmall;

	if ( ExtractIconExT( path, iconNum, &hIconLarge, &hIconSmall, 1 ) == 0 )
	{
		ODSF( L"ExtractIconExT returns 0, last error %d", GetLastError() );
		return NULL;
	}

	HBITMAP hBmp = IconToBitmap( hIconSmall );

	DestroyIcon( hIconLarge );
	DestroyIcon( hIconSmall );

	return hBmp;


	//// Gets shell icon

	//UINT uFlags = SHGFI_ICON | SHGFI_USEFILEATTRIBUTES | SHGFI_SMALLICON;

	//SHFILEINFOW sfi;
	//memset( &sfi, 0, sizeof( sfi ) );

	//sfi.iIcon = iconNum;

	//if ( !SHGetFileInfoT( path, 0, &sfi, sizeof(sfi), uFlags ) )
	//	return NULL;

	//return IconToBitmap( sfi.hIcon );
}