#pragma once

DWORD GetFullPathNameT( 
    LPCWSTR lpFileName,
    DWORD nBufferLength,
    LPWSTR lpBuffer,
    LPWSTR *lpFilePart
	);

BOOL
WaitNamedPipeT(
	LPCWSTR lpNamedPipeName,
	DWORD nTimeOut
	);

HANDLE
OpenSemaphoreT(
    DWORD dwDesiredAccess,
    BOOL bInheritHandle,
    LPCWSTR lpName
    );

HANDLE
CreateSemaphoreT(
    LPSECURITY_ATTRIBUTES lpSemaphoreAttributes,
    LONG lInitialCount,
    LONG lMaximumCount,
    LPCWSTR lpName
);

//
//	renameT
//		The difference with MoveFile is it allows to rename busied file on single disk 
//
int renameT( const wchar_t *oldName, const wchar_t *newName );

BOOL
SetWindowTextT(
    HWND hWnd,
    LPCWSTR lpString);

int ListView_InsertItemT( HWND hwnd, LVITEMW *pitem );
BOOL ListView_GetColumnT( HWND hwnd, int iCol, LV_COLUMNW *pcol);
BOOL ListView_SetColumnT( HWND hwnd, int iCol, const LV_COLUMNW *pcol);
int ListView_InsertColumnT( HWND hwnd, int iCol, const LV_COLUMNW *pcol );
int ListView_FindItemT( HWND hwnd, int iStart, const LVFINDINFOW *plvfi );

//
//	Pure Windows 95 does not support size with hBmpItem for MENUITEMINFO
//		The size is used in Window 95 version for menu functions
//			InsertMenuItemT, SetMenuItemInfoT, GetMenuItemInfoT
//
#ifndef MENUITEMINFO_SIZE_VERSION_400
#	ifdef CDSIZEOF_STRUCT
#		define MENUITEMINFO_SIZE_VERSION_400  CDSIZEOF_STRUCT(MENUITEMINFOA,cch)
#	else
#		define MENUITEMINFO_SIZE_VERSION_400  sizeof( MENUITEMINFOA )
#	endif
#endif // MENUITEMINFO_SIZE_VERSION_400

BOOL
InsertMenuItemT(
		HMENU,
		UINT,
		BOOL,
		LPCMENUITEMINFOW
    );

BOOL
ModifyMenuT(
    IN HMENU hMnu,
    IN UINT uPosition,
    IN UINT uFlags,
    IN UINT_PTR uIDNewItem,
    IN LPCWSTR lpNewItem
    );

BOOL
SetMenuItemInfoT(
    IN HMENU hMenu,
    IN UINT uItem,
    IN BOOL fByPosition,
    IN LPMENUITEMINFOW lpmii
    );

//
//	GetMenuStringT
//	works properly for NT 4, instead of GetMenuTextT
//
int
GetMenuStringT(
    HMENU hMenu,
    UINT uIDItem,
    LPWSTR lpString,
    int cchMax,
    UINT flags );

BOOL
GetMenuItemInfoT(
		IN HMENU hMenu,
		IN UINT uItem,
		IN BOOL fByPosition,
		IN OUT LPMENUITEMINFOW lpmii
    );

BOOL GetTextExtentPoint32T( HDC hdc, LPCWSTR lpString, int cbString, LPSIZE lpSize );

int
DrawTextT(
    IN HDC hDC,
    IN LPCWSTR lpString,
    IN int nCount,
    IN OUT LPRECT lpRect,
    IN UINT uFormat );

LRESULT
CallWindowProcT(
	WNDPROC lpPrevWndFunc,
	HWND hWnd,
	UINT Msg,
	WPARAM wParam,
	LPARAM lParam );

UINT
GetWindowsDirectoryT(
    LPWSTR lpBuffer,
    UINT uSize
    );

UINT
GetSystemDirectoryT(
    OUT LPWSTR lpBuffer,
    IN UINT uSize
    );

HINSTANCE
FindExecutableT(
	LPCWSTR lpFile,
	LPCWSTR lpDirectory,
	LPWSTR lpResult
	);

HINSTANCE
ShellExecuteT(
	HWND hWnd,
	LPCWSTR lpOperation,
	LPCWSTR lpFile,
	LPCWSTR lpParameters,
	LPCWSTR lpDirectory,
	INT nShowCmd
	);

BOOL ShellExecuteExT( SHELLEXECUTEINFOW *lpExecInfo );
UINT DragQueryFileT( HDROP hDrop, UINT num, LPWSTR wbuff, UINT wbflen );

UINT GetDriveTypeT( LPCWSTR lpRootPathName );

BOOL
GetDiskFreeSpaceT(
    LPCWSTR lpRootPathName,
    LPDWORD lpSectorsPerCluster,
    LPDWORD lpBytesPerSector,
    LPDWORD lpNumberOfFreeClusters,
    LPDWORD lpTotalNumberOfClusters
    );

BOOL WinHelpT( HWND hWndMain, LPCWSTR lpszHelp, UINT uCommand, DWORD dwData );

#ifdef _UseHtmlHelp_
//
//	HtmlHelpT
//		1. HtmlHelp.lib has to be mantioned at included list.
//		2. _UseHtmlHelp_ has to be definded
//
HWND HtmlHelpT( HWND hwndCaller, LPCWSTR pszFile, UINT uCommand, DWORD_PTR dwData );
#endif

BOOL TreeView_GetItemT( HWND hwnd, TV_ITEMW *pitem );
BOOL TreeView_SetItemT( HWND hwnd, const TV_ITEMW *pitem );
HTREEITEM TreeView_InsertItemT( HWND hwnd, LPTV_INSERTSTRUCTW lpis );

int
WINAPI
MessageBoxIndirectT(
    IN CONST MSGBOXPARAMSW *lpMsgBoxParams );

BOOL SetCurrentDirectoryT( LPCWSTR lpPathName );
DWORD GetCurrentDirectoryT(
  DWORD nBufferLength,  // size of directory buffer
  LPWSTR lpBuffer       // directory buffer
);

BOOL
CreateProcessT(
    IN LPCWSTR lpApplicationName,
    IN LPWSTR lpCommandLine,
    IN LPSECURITY_ATTRIBUTES lpProcessAttributes,
    IN LPSECURITY_ATTRIBUTES lpThreadAttributes,
    IN BOOL bInheritHandles,
    IN DWORD dwCreationFlags,
    IN LPVOID lpEnvironment,
    IN LPCWSTR lpCurrentDirectory,
    IN LPSTARTUPINFOW lpStartupInfo,
    OUT LPPROCESS_INFORMATION lpProcessInformation
    );

LONG
RegCreateKeyExT (
    IN HKEY hKey,
    IN LPCWSTR lpSubKey,
    IN DWORD Reserved,
    IN LPWSTR lpClass,
    IN DWORD dwOptions,
    IN REGSAM samDesired,
    IN LPSECURITY_ATTRIBUTES lpSecurityAttributes,
    OUT PHKEY phkResult,
    OUT LPDWORD lpdwDisposition
    );

LONG
RegCreateKeyT (
    IN HKEY hKey,
    IN LPCWSTR lpSubKey,
    OUT PHKEY phkResult
    );

LONG
RegOpenKeyExT (
    IN HKEY hKey,
    IN LPCWSTR lpSubKey,
    IN DWORD ulOptions,
    IN REGSAM samDesired,
    OUT PHKEY phkResult
    );

LONG
RegQueryInfoKeyT (
    IN HKEY hKey,
    OUT LPWSTR lpClass,
    IN OUT LPDWORD lpcbClass,
    IN LPDWORD lpReserved,
    OUT LPDWORD lpcSubKeys,
    OUT LPDWORD lpcbMaxSubKeyLen,
    OUT LPDWORD lpcbMaxClassLen,
    OUT LPDWORD lpcValues,
    OUT LPDWORD lpcbMaxValueNameLen,
    OUT LPDWORD lpcbMaxValueLen,
    OUT LPDWORD lpcbSecurityDescriptor,
    OUT PFILETIME lpftLastWriteTime
    );

LONG
RegDeleteKeyT(
    IN HKEY hKey,
    IN LPCWSTR lpSubKey
    );

LONG
RegDeleteValueT(
    IN HKEY hKey,
    IN LPCWSTR lpValueName
    );

LONG
RegEnumKeyExT (
    IN HKEY hKey,
    IN DWORD dwIndex,
    OUT LPWSTR lpName,
    IN OUT LPDWORD lpcbName,
    IN LPDWORD lpReserved = NULL,
    IN OUT LPWSTR lpClass = NULL,
    IN OUT LPDWORD lpcbClass = NULL,
    OUT PFILETIME lpftLastWriteTime = NULL
    );

LONG
RegEnumValueT (
    IN HKEY hKey,
    IN DWORD dwIndex,
    OUT LPWSTR lpValueName,
    IN OUT LPDWORD lpcbValueName,
    IN LPDWORD lpReserved,
    OUT LPDWORD lpType,
    OUT LPBYTE lpData,
    IN OUT LPDWORD lpcbData
    );

LONG
RegSetValueExT (
    IN HKEY hKey,
    IN LPCWSTR lpValueName,
    IN DWORD Reserved,
    IN DWORD dwType,
    IN CONST BYTE* lpData,
    IN DWORD cbData
    );

BOOL SetDlgItemTextT( HWND hDlg, int nIDDlgItem, const wchar_t *lpString );
LRESULT SendSettingChangeMessageT( HWND hWnd, WPARAM wParam, const wchar_t *section );
HMODULE GetModuleHandleT( LPCWSTR lpModuleName );

HMODULE
LoadLibraryExT(
    IN LPCWSTR lpLibFileName,
    IN HANDLE hFile = NULL,
    IN DWORD dwFlags = 0
    );

BOOL
GetComputerNameT(
    OUT LPWSTR lpBuffer,
    IN OUT LPDWORD nSize
    );

DWORD
GetEnvironmentVariableT(
    IN LPCWSTR lpName,
    OUT LPWSTR lpBuffer,
    IN DWORD nSize
    );

ATOM RegisterClassExT( CONST WNDCLASSEXW * lpWndClass );
ATOM RegisterClassT( CONST WNDCLASSW *lpWndClass );

HWND
FindWindowExT(
    __in_opt HWND hWndParent,
    __in_opt HWND hWndChildAfter,
    __in_opt LPCWSTR lpszClass,
    __in_opt LPCWSTR lpszWindow );

HWND
FindWindowT(
    __in_opt LPCWSTR lpClassName,
    __in_opt LPCWSTR lpWindowName );

HWND
CreateWindowExT(
    IN DWORD dwExStyle,
    IN LPCWSTR lpClassName,
    IN LPCWSTR lpWindowName,
    IN DWORD dwStyle,
    IN int X,
    IN int Y,
    IN int nWidth,
    IN int nHeight,
    IN HWND hWndParent,
    IN HMENU hMenu,
    IN HINSTANCE hInstance,
    IN LPVOID lpParam );

LRESULT
DefWindowProcT( HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam );

BOOL
GetMessageT(
	LPMSG lpMsg,
	HWND hWnd,
	UINT wMsgFilterMin,
	UINT wMsgFilterMax );

LRESULT
DispatchMessageT( CONST MSG *lpMsg );

int
TranslateAcceleratorT(
	HWND hWnd,
	HACCEL hAccTable,
	LPMSG lpMsg );

BOOL TextOutT( HDC hdc, int nXStart, int nYStart, LPCWSTR lpString, int cbString );
int
GetDateFormatT(
    IN LCID             Locale,
    IN DWORD            dwFlags,
    IN CONST SYSTEMTIME *lpDate,
    IN LPCWSTR          lpFormat,
    OUT LPWSTR          lpDateStr,
    IN int              cchDate);

int
GetTimeFormatT(
    IN LCID             Locale,
    IN DWORD            dwFlags,
    IN CONST SYSTEMTIME *lpTime,
    IN LPCWSTR          lpFormat,
    OUT LPWSTR          lpTimeStr,
    IN int              cchTime);

int TabCtrl_InsertItemT( HWND hwnd, int iItem, TCITEMW *pitem );
bool Toolbar_InsertButtonT( HWND hToolbar, int iButton,  TBBUTTON *tbb );

DWORD
GetPrivateProfileStringT(
    IN LPCWSTR lpAppName,
    IN LPCWSTR lpKeyName,
    IN LPCWSTR lpDefault,
    OUT LPWSTR lpReturnedString,
    IN DWORD nSize,
    IN LPCWSTR lpFileName
    );

DWORD
GetLogicalDriveStringsT(
    IN DWORD nBufferLength,
    OUT LPWSTR lpBuffer
    );

DWORD
GetCompressedFileSizeT(
    IN LPCWSTR lpFileName,
    OUT LPDWORD lpFileSizeHigh
    );

//
//	Sends message in unicode for NT and ANSI for 95
//
LRESULT SendMessageT( IN HWND hWnd, IN UINT MsgW, IN UINT MsgA, IN WPARAM wParam, const wchar_t *lParam );

DWORD
ExpandEnvironmentStringsT(
    IN LPCWSTR lpSrc,
    OUT LPWSTR lpDst,
    IN DWORD nSize
    );


HRSRC FindResourceT( HMODULE hModule, int idRes, const wchar_t *rcType );

BOOL
FindNextFileT(
    HANDLE hFindFile,
    LPWIN32_FIND_DATAW lpFindFileData
    );

int GetWindowTextLengthT( HWND hWnd );

LPITEMIDLIST SHBrowseForFolderT(LPBROWSEINFOW lpbi);
BOOL SHGetPathFromIDListT(LPCITEMIDLIST pidl, LPWSTR pszPath);
BOOL Shell_NotifyIconT( DWORD dwMessage, PNOTIFYICONDATAW lpData );

DWORD
GetLongPathNameT(
    IN LPCWSTR lpszShortPath,
    OUT LPWSTR  lpszLongPath,
    IN DWORD    cchBuffer
    );

DWORD
GetModuleFileNameT(
    IN HMODULE hModule,
    OUT LPWSTR lpFilename,
    IN DWORD nSize
    );

BOOL SHGetSpecialFolderPathT( HWND hwnd, LPWSTR pszPath, int csidl, BOOL fCreate );
