#pragma once

#include "cDlg.h"

//
// cDlgProgressMT class created instead of CProgressMT
//

class cDlgProgressMT;
typedef DWORD typeThreadProc( cDlgProgressMT *dlg );

class cDlgProgressMT : public cDlg
{
public:

	int m_idIcon;

	//
	//	items at hWnd and idc tables are placed accoding following enumerating.
	//
	enum { enText = 0, enProgress, enPercent, enMax };
	int *m_idcT;			// Table with idetifiers according enumeration above. May be passed as parameter.
	HWND m_hWndT[ enMax ];	// Table with window handles according enumeration above. Is filled by m_idcT at init dialog.

	//
	//	updateHandles is called at InitDialog
	//		if m_idcT is not NULL the m_hWndT is updated according the m_idcT
	//		otherwise it tries to update the m_hWndT table automatically
	//
	void updateHandles();
	bool updateTable( HWND hWnd );
	
	bool m_cancelled;

	static DWORD WINAPI staticThreadProc(  void *param );

	DWORD m_dwRes; // Result of thread proc.

	cDlgProgressMT( typeThreadProc *proc, int idsTerminateQ, const wchar_t *caption, const wchar_t *text, int *idcT = NULL );
	~cDlgProgressMT();
	void setProgressPosition( int position );

	//
	//	wmStopMessage
	//		is sent when thread process is finished or stopped
	//		WPARAM is error number or noError
	//		LPARAM is thread function return code
	//
	enum { wmStopMessage = (WM_USER + 5), noError = 0 };

	HANDLE m_threadHandle;
	DWORD m_threadID;
	cWCStr m_text;
	cWCStr m_caption;

	int m_idsTerminateQ;

	typeThreadProc *m_threadProc;

	//
	//	The typeThreadProc function gets pointer to cDlgProgressMT class.
	//	If m_pVoidParam is not NULL it is direct void pointer to the class really required for procesing.
	//
	void *m_pVoidParam;

	void OnCancel();

	virtual LRESULT RealDlgProc( UINT uMsg, WPARAM wParam, LPARAM lParam );
};