#pragma once

#include <windows.h>

class cFileIcon
{
public:

	HICON *m_hIconT;
	int m_iconQ;

	cFileIcon( const wchar_t *filePath, int index = -1 )
	{
		m_hIconT = NULL;
		m_iconQ = 0;

		extractIcon( filePath, index );
	}

	cFileIcon( HMODULE hInst, int index )
	{
		m_hIconT = NULL;
		m_iconQ = 0;

		wchar_t path[ MAX_PATH ];

		GetModuleFileNameW( hInst, path, maxLen( path ) );
		
		extractIcon( path, index );
	}
	
	~cFileIcon()
	{
		freeTable();
	}

	void freeTable()
	{
		if ( m_hIconT != NULL )
		{
			while( m_iconQ-- )
			{
				if ( m_hIconT[ m_iconQ ] != NULL )
					DestroyIcon( m_hIconT[ m_iconQ ] );
			}
			
			delete( m_hIconT );
		}
		
		m_hIconT = NULL;
	}

private:

	bool extractIcon( const wchar_t *filePath, int index )
	{
		if ( index == -1 )
		{
			index = ExtractIconExW( filePath, -1, NULL, NULL, 1 );
			if ( index <= 0 )
				return false;
		}

		freeTable();

		m_hIconT = new HICON[ index ];

		if ( m_hIconT == NULL )
			return false;

		m_iconQ = index;

		for( int i = 0; i < m_iconQ; i++ )
			m_hIconT[i] = NULL;
		
		int res = ExtractIconExW( filePath, 0, NULL, m_hIconT, index );

		return ( res > 0 );
	}
};
