#include "cSplitter.h"
#include "UnicodeFuncs.h"

bool cSplitter::m_isRegisterred = false;
const wchar_t *cSplitter::m_szClassName = L"BCSplitterWClass";

RECT cSplitter::GetRect( HWND hWnd )
{
	if ( hWnd == NULL )
		hWnd = m_hWnd;

	RECT r;
	GetWindowRect( hWnd, &r );

	MapWindowPoints( NULL, m_hParent, (LPPOINT)&r, 2 );

	return r;
}

//void SetBrush( HWND hWnd, bool draged )
//{
//	//draged = !draged;
////	HBRUSH hBrush = draged ? (HBRUSH)GetStockObject(LTGRAY_BRUSH) : NULL;
//
////	SetClassLongPtrA( hWnd, GCLP_HBRBACKGROUND, (LONG_PTR)hBrush );
////	RedrawWindow( hWnd, NULL, NULL, RDW_INTERNALPAINT );
////	RedrawWindow( hWnd, NULL, NULL, RDW_ERASENOW );
//	RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE );
////	RedrawWindow( hWnd, NULL, NULL, RDW_ERASE );
//}

void cSplitter::OnMouseMove( DWORD vKeys, short x, short y )
{
	if ( !m_draged )
		return;

	RECT r = GetRect( m_hWnd );
	RECT rr = GetRect( m_hRightBottom );
	RECT rl = GetRect( m_hLeftTop );

	if ( m_bVertical )
	{
		bool moveUp = y - m_posY < 0;

		if ( ( r.top < 5 + rl.top ) && moveUp )
			return;

		if ( ( rr.bottom - ( rr.top - rl.bottom ) < r.bottom ) && !moveUp )
			return;

		SetWindowPos( m_hWnd, HWND_TOP, r.left, r.top + y - m_posY, 0, 0, SWP_NOSIZE | SWP_NOZORDER ); 
	}
	else
	{
		if ( ( r.left < 5 ) && ( x - m_posX < 0 ) )
			return;

		if ( ( rr.right - r.right < 5 ) && ( x - m_posX > 0 ) )
			return;

		SetWindowPos( m_hWnd, HWND_TOP, r.left + x - m_posX, r.top, 0, 0, SWP_NOSIZE | SWP_NOZORDER ); 
	}
}

void cSplitter::OnLButtonDown( DWORD vKeys, short x, short y )
{
	m_rect = GetRect( m_hWnd );
	m_rSave = m_rect;
	m_posX = x;
	m_posY = y;

	SetCapture( m_hWnd );
	m_draged = true;
	RedrawWindow( m_hWnd, NULL, NULL, RDW_INVALIDATE );
}

void cSplitter::OnLButtonUp( DWORD vKeys, short x, short y )
{
	ShowWindow( m_hWnd, SW_HIDE );

	ReleaseCapture();

	RECT r = GetRect( m_hWnd );
	moveClients( &r );

	m_draged = false;
	SetWindowPos( m_hWnd, HWND_TOP, 0, 0, 0, 0, SWP_SHOWWINDOW | SWP_NOMOVE | SWP_NOSIZE );
}

static wchar_t *valueName = L"SplitterPos";

bool cSplitter::saveWindowPos( RECT *r )
{
	if ( m_regKeyName == NULL )
		return false;

	HKEY hKey;
	LONG res = RegOpenKeyExT( m_hRegRoot, m_regKeyName, 0, KEY_WRITE, &hKey );

	if ( res != ERROR_SUCCESS )
		return false;

	res = RegSetValueExT( hKey, valueName, 0, REG_BINARY, (BYTE *)r, sizeof( RECT ) );

	RegCloseKey( hKey );

	return ( res == ERROR_SUCCESS );
}

bool cSplitter::getWindowPos( RECT *r )
{
	if ( m_regKeyName == NULL )
		return false;

	HKEY hKey;
	LONG res = RegOpenKeyExT( m_hRegRoot, m_regKeyName, 0, KEY_READ, &hKey );

	if ( res != ERROR_SUCCESS )
		return false;

	DWORD dwSize = 0;
	DWORD dwType = REG_BINARY;
	res = RegQueryValueExT( hKey, valueName, 0, &dwType, NULL, &dwSize );

	if ( ( dwSize != sizeof( RECT ) ) || ( dwType != REG_BINARY ) )
	{
		RegCloseKey( hKey );
		return false;
	}

	res = RegQueryValueExT( hKey, valueName, 0, &dwType, (BYTE *)r, &dwSize );

	RegCloseKey( hKey );

	if ( res != ERROR_SUCCESS )
		return false;

//	MoveWindow( hWnd, r.left, r.top, r.right - r.left, r.bottom - r.top, true );

	return true;
	
}

void cSplitter::Close()
{
	if ( m_hWnd != NULL )
	{
		RECT r;
		GetWindowRect( m_hWnd, &r );
		MapWindowPoints( NULL, GetParent( m_hWnd ), (LPPOINT)&r, 2 );

		saveWindowPos( &r );

		DestroyWindow( m_hWnd );
	}

	m_hWnd = NULL;
}

void cSplitter::Init( HWND hParent, HWND hLeftTop, HWND hRightBottom, HWND *nestedT, int nestedQ )
{
	m_flip = isRTLProcessLayout(); // ( pTranslateDll != NULL ) && pTranslateDll->m_flipDialog;
	m_draged = false;
	m_hParent= hParent;
	m_hLeftTop  = hLeftTop;
	m_hRightBottom = hRightBottom;

	RECT crl, crr;
	crr = GetRect( m_hRightBottom );
	crl = GetRect( m_hLeftTop );

	if ( crl.bottom < crr.top )
		m_bVertical = true;

	POINT plu; // Left Up corner
	POINT prd; // Right Down corner

	HCURSOR hCursor = NULL;

	if ( m_bVertical )
	{
		plu.x = crl.left;
		plu.y = crl.bottom;
		prd.x = crr.right;
		prd.y = crr.top;

		if ( prd.y - plu.y > m_sizeMax )
		{
			m_dy = prd.y - plu.y - m_sizeMax;
			prd.y -= m_dy;
		}
		
		hCursor = LoadCursor(NULL, IDC_SIZENS );
	}
	else
	{
		plu.x = crl.right;
		prd.x = crr.left;
		//plu.y = crl.bottom;
		//prd.y = crr.top;
		
		plu.y = crl.top;
		prd.y = crl.bottom;

		if ( prd.x - plu.x > m_sizeMax )
		{
			m_dx = prd.x - plu.x - m_sizeMax;
			prd.x -= m_dx;
		}

		hCursor = LoadCursor(NULL, IDC_SIZEWE );
	}

#ifndef WS_EX_LAYOUTRTL
#define WS_EX_LAYOUTRTL         0x00400000L // Right to left mirroring
#endif

 	m_hWnd = CreateWindowExT(
		( m_flip ? WS_EX_LAYOUTRTL : 0 ),
		m_szClassName,
		NULL,
		WS_CHILD | WS_VISIBLE | CS_HREDRAW | CS_VREDRAW,
		plu.x, plu.y, prd.x - plu.x, prd.y - plu.y,
		hParent, NULL,
		m_hInst,
		this );

	assert( m_hWnd != NULL );

	SetClassLongPtrT( m_hWnd, GCLP_HCURSOR, (LONG_PTR)hCursor );

	RECT r;
	if ( !getWindowPos( &r ) )
		r = GetRect( m_hWnd );
	else
	{
		r.top = GetRect( m_hWnd ).top; // If toolbar size was changed.
		moveClients( &r );
	}

	GetWindowRect( m_hWnd, &m_rect );

	if ( nestedQ != 0 )
	{
		m_nestedT = new HWND[ nestedQ ];
		if ( m_nestedT != NULL )
		{
			for ( ; m_nestedQ < nestedQ; m_nestedQ++ )
			{
				m_nestedT[ m_nestedQ ] = nestedT[ m_nestedQ ];
			}
		}
	}
}

void cSplitter::moveClients( RECT *rs )
{
	RECT rl, rr;
	rl = GetRect( m_hLeftTop );
	rr = GetRect( m_hRightBottom );

	int nestedDX = 0;
	int nestedDY = 0;

	if ( m_bVertical )
	{
		LONG prevTopPos = rl.bottom;

		nestedDY = rs->top - rl.bottom;
		rl.bottom = rs->top;
		rr.top  = rs->bottom + m_dy;

		if ( rl.bottom - rl.top <= 0 )
		{
			MoveWindow( m_hWnd, rs->left, prevTopPos, rs->right - rs->left, rs->bottom - rs->top, false );
			return;
		}
	}
	else
	{
		LONG prevLeftPos = rl.right;

		nestedDX = rs->left - rl.right;
		rl.right = rs->left;
		rr.left  = rs->right + m_dx;

		if ( rl.right - rl.left <= 0 )
		{
			MoveWindow( m_hWnd, prevLeftPos, rs->top, rs->right - rs->left, rs->bottom - rs->top, false );
			return;
		}
	}

	MoveWindow( m_hWnd, rs->left, rs->top, rs->right - rs->left, rs->bottom - rs->top, false );
	MoveWindow( m_hLeftTop, rl.left, rl.top, rl.right - rl.left, rl.bottom - rl.top, false );
	MoveWindow( m_hRightBottom, rr.left, rr.top, rr.right - rr.left, rr.bottom - rr.top, false );

	if ( m_nestedT != NULL )
	{
		for( int i = m_nestedQ; i--; )
		{
			HWND hWnd = m_nestedT[i];
			RECT rn = GetRect( hWnd );
			MoveWindow( hWnd, rn.left + nestedDX, rn.top + nestedDY, rn.right - rn.left, rn.bottom - rn.top, false );
		}
	}

	RedrawWindow( m_hParent, NULL, NULL, RDW_INVALIDATE );
}

// static 
bool cSplitter::RegisterClass( HINSTANCE hInst )
{
	if ( m_isRegisterred )
		return true;

	WNDCLASSEXW wcx; 

	memset( &wcx, 0, sizeof( wcx ) );

	wcx.cbSize = sizeof(wcx);
	wcx.style = CS_HREDRAW | CS_VREDRAW;
	wcx.lpfnWndProc = staticWndProc;	// points to window procedure 
	wcx.hInstance = hInst;
	wcx.hIcon = NULL;
	wcx.hCursor = LoadCursor(NULL, IDC_SIZEWE );
	wcx.hbrBackground = NULL; // (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wcx.lpszClassName = m_szClassName;

	// Register the window class. 

	m_isRegisterred = ( RegisterClassExT(&wcx) != 0 );

	return m_isRegisterred;
}

//static 
LRESULT CALLBACK cSplitter::staticWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	cSplitter *pThis;

	if ( uMsg == WM_CREATE )
	{
		CREATESTRUCT *pcs = (CREATESTRUCT *)lParam;

		pThis = (cSplitter *)pcs->lpCreateParams;
		pThis->m_hWnd = hWnd;

		SetWindowLongPtrT( hWnd, GWLP_USERDATA, (LONG_PTR)pThis );
		return 0;
	}

	pThis = (cSplitter *)GetWindowLongPtrT( hWnd, GWLP_USERDATA );

	if ( pThis != NULL )
	{
		assert( pThis->m_hWnd == hWnd );

		LRESULT lRes = pThis->RealWndProc( uMsg, wParam, lParam );

		if ( lRes != 0 )
			return lRes;
	}

	return DefWindowProcT( hWnd, uMsg, wParam, lParam );
}

LRESULT CALLBACK cSplitter::RealWndProc( UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch ( uMsg )
	{
		case WM_MOUSEMOVE:
		{
			DWORD_PTR dw = (DWORD_PTR)lParam;
			OnMouseMove( (DWORD)(DWORD_PTR)wParam, LOWORD(dw), HIWORD(dw) );
			return 0;
		}
		case WM_LBUTTONDOWN:
		{
			DWORD_PTR dw = (DWORD_PTR)lParam;
			OnLButtonDown( (DWORD)(DWORD_PTR)wParam, LOWORD(dw), HIWORD(dw) );
			return 0;
		}
		case WM_LBUTTONUP:
		{
			DWORD_PTR dw = (DWORD_PTR)lParam;
			OnLButtonUp( (DWORD)(DWORD_PTR)wParam, LOWORD(dw), HIWORD(dw) );
			return 0;
		}
		//case WM_ERASEBKGND:
		//{
		//	SetBkMode( HDC( wParam ), TRANSPARENT );
		//	//SetBkMode( HDC( wParam ), m_draged ? TRANSPARENT : OPAQUE );
		//	break;
		//}
		case WM_PAINT:
		{
			if ( !m_draged )
				return 0;

			PAINTSTRUCT ps;	
			HDC hDC = BeginPaint( m_hWnd, &ps );

			RECT r = GetRect( m_hWnd );

//			SetBkMode( hDC, TRANSPARENT );

			MapWindowPoints( m_hParent, m_hWnd, (POINT*)&r, 2 );

//			if ( m_draged )
			{
				FillRect( hDC, &r, (HBRUSH)GetStockObject(LTGRAY_BRUSH) );
				//DrawEdge( hDC, &r, BDR_RAISED, BF_RECT ); //BF_DIAGONAL_ENDBOTTOMLEFT );
			}

			//if ( m_draged )
			//{
			//	HPEN redPen = CreatePen( PS_SOLID, 1, RGB( 0xFF, 0, 0 ) );

			//	HPEN oldPen = (HPEN)SelectObject( hDC, redPen );
			//	POINT pt;
			//	MoveToEx( hDC, 0, 0, &pt );
			//	LineTo( hDC, r.right, r.bottom );

			//	SelectObject( hDC, oldPen );
			//	DeleteObject( redPen );

			//	MoveToEx( hDC, pt.x, pt.y, NULL );
			//}

			EndPaint( m_hWnd, &ps );

			return 0;
		}
		default:
			return 0;
	}

	return 1;
}

