#include "cStringBuffer.h"
#include "ODS.h"
#include "cSaveValue.h"
#ifdef _ODS
#include "FileView.h"
#endif

void cStringBuffer::InitA( BYTE *bf, SIZE_T bfSize )
{
	m_startPos = 0;
	m_bf = bf;
	m_bfSize = bfSize;

	m_isUnicode = false;
	
	Restart();
}

template < class symT > bool readString( cStringBuffer *pThis, symT *buff, int buffSize, bool *pCompleted )
{
	if ( !pThis->UpdateMapping() )
		return false;

	int i;

	bool bCompleted = false;
	
	if ( pCompleted == NULL ) // Complete operation flag, is false if string was not read to it's end.
		pCompleted = &bCompleted;

	*pCompleted = false;

	bool bTabulationAsNewLine = pThis->m_bTabulationAsNewLine;

	for( i = 0; ; i++ )
	{
		if ( i >= buffSize )
		{
			buff[ buffSize - 1 ] = 0;
			break;
		}

		//
		// 20.02.2010
		//
		if ( pThis->m_pos >= pThis->m_bfSize )
		{
			if ( i == 0 )
				return false;

			//
			//	22.02.2010
			//	Last string is not terminated by \r\n is valid.
			//
			buff[ i ] = (symT)L'\0';
			*pCompleted = true;
			return true;
		}

		symT ch = *( symT *) ( pThis->m_bf + pThis->m_pos );

		//
		//	20.02.2010
		//
		if ( ch == 0 )
		{
			ODS_fls( L"Assertion: zero character is detected" );
			//return false;
		}

		if ( ( ch == (symT)L'\r' ) || ( ch == (symT)L'\n' ) || ( bTabulationAsNewLine && ch == (symT)L'\t' ) )
		{
			buff[ i ] = (symT)L'\0';

			// 
			//	21.06.2010
			//		
			symT *s = (symT *)(pThis->m_bf + pThis->m_pos);

			if ( ( s[0] == (symT)L'\r' ) &&
				 ( s[1] == (symT)L'\n' ) 
				 )
				pThis->m_pos += 2 * sizeof( symT );
			else
				pThis->m_pos += sizeof( symT );

			if ( ( i == 0 ) && pThis->m_skipEmptyString )
			{
				i--; // It will be incremented back by loop.
				continue;
			}

			*pCompleted = true;

			break;
		}
		else
		{
			buff[ i ] = ch;
			if ( pThis->m_pos >= pThis->m_bfSize )
			{
				if ( i < buffSize - 1 )
					i++;
				buff[ i ] = (symT)L'\0';
				break;
			}
			else
				pThis->m_pos += sizeof( symT );
		}
	}

	//ODSFuncRes( buff );

	return true;
}

int cStringBuffer::GetStringQ()
{
	cSaveValue < SIZE_T > sv( &m_pos );
	
	Restart();

	wchar_t tmp[ 1024 ];

	int q = 0;
	while( ReadStringT( tmp, maxLen( tmp ) ) )
		q++;
	
	return q;
}

bool cStringBuffer::ReadStringA( char *buff, int buffSize )
{
	return readString( this, buff, buffSize, &m_bCompleted );

	// It has to be same as ReadStringW

	//int i;

	//for( i = 0; ; i++ )
	//{

	//	if ( i >= buffSize )
	//	{
	//		buff[ buffSize - 1 ] = '\0';
	//		break;
	//	}

	//	//
	//	// 20.02.2010
	//	//
	//	if ( m_pos >= m_bfSize )
	//	{
	//		if ( i == 0 )
	//			return false;

	//		//
	//		//	22.02.2010
	//		//	Last string is not terminated by \r\n is valid.
	//		//
	//		buff[ i ] = '\0';
	//		return true;
	//	}

	//	char ch = *( char *) ( m_bf + m_pos );

	//	//
	//	//	20.02.2010
	//	//
	//	if ( ch == '\0' )
	//	{
	//		ODS_fls( L"Assertion: zero character is detected" );
	//		//return false;
	//	}

	//	if ( ( ch == '\r' ) || ( ch == '\n' ) )
	//	{
	//		buff[ i ] = '\0';

	//		if ( !m_skipEmptyString )
	//		{
	//			if ( strncmp( (char *)(m_bf + m_pos), "\r\n", 2 ) == 0 )
	//				m_pos += 2;
	//			else
	//				m_pos += 1;
	//		}
	//		else
	//		{
	//			// Skips all \r \n symbols for next string
	//			do
	//			{
	//				if ( m_pos >= m_bfSize )
	//					break;
	//				else
	//				{
	//					m_pos += 1;
	//					if ( m_pos >= m_bfSize )
	//						break;
	//				}

	//				ch = *( char *) ( m_bf + m_pos );
	//			}
	//			while( ( ch == '\r' ) || ( ch == '\n' ) );
	//		}

	//		break;
	//	}
	//	else
	//	{
	//		buff[ i ] = ch;
	//		if ( m_pos >= m_bfSize )
	//		{
	//			if ( i < buffSize - 1 )
	//				i++;
	//			buff[ i ] = '\0';
	//			break;
	//		}
	//		else
	//			m_pos += 1;
	//	}
	//}

	////ODSFuncRes( buff );

	//return true;

	////if ( m_pos >= m_bfSize )
	////	return false;

	////int i;
	////for( i = 0; ; i++ )
	////{
	////	char ch = m_bf[ m_pos ];
	////	if ( ( ch == '\r' ) || ( ch == '\n' ) )
	////	{
	////		if ( i >= buffSize )
	////			buff[ buffSize - 1 ] = '\0';
	////		else
	////			buff[ i ] = '\0';

	////		if ( !m_skipEmptyString && ( memcmp( m_bf + m_pos, "\r\n", 2 ) == 0 ) )
	////		{
	////			m_pos += 2;
	////		}
	////		else
	////		{
	////			// Skips all \r \n symbols for next string
	////			do
	////			{
	////				if ( m_pos >= m_bfSize )
	////					break;
	////				else
	////				{
	////					m_pos++;
	////					if ( m_pos >= m_bfSize )
	////						break;
	////				}
	////				ch = m_bf[ m_pos ];
	////			}
	////			while( ( ch == '\r' ) || ( ch == '\n' ) );
	////		}

	////		break;
	////	}
	////	else
	////	{
	////		if ( i >= buffSize )
	////			buff[ buffSize - 1 ] = '\0';
	////		else
	////			buff[ i ] = ch;

	////		if ( m_pos >= m_bfSize )
	////		{
	////			if ( i < buffSize - 1 )
	////				i++;

	////			if ( i >= buffSize )
	////				buff[ buffSize - 1 ] = '\0';
	////			else
	////				buff[ i ] = '\0';

	////			break;
	////		}
	////		else
	////			m_pos++;
	////	}
	////}

	////return true;
}

#ifdef _WIN32

bool ConvertFromBigEndian( cPlainTextBlock *ptb, const BYTE *bf, int bfSize )
{
	if ( ptb->Allocate( bfSize ) == NULL )
		return false;

	for( int i = 0; i <= bfSize - 2; i+=2 )
	{
		ptb->buffer[ i ] = bf[ i + 1 ];
		ptb->buffer[ i + 1 ] = bf[ i ];
	}

	return true;
}

bool ConvertFromACP( cPlainTextBlock *ptb, const BYTE *bf, int bfSize )
{
	UINT codePage = CP_ACP;
	int size = MultiByteToWideChar( codePage, 0, ( char * )bf, bfSize, NULL, 0 );

	if ( size == 0 )
		return bfSize == 0;

	if ( ptb->Allocate( size * sizeof( wchar_t ) ) == NULL )
		return false;

	size = MultiByteToWideChar( codePage, 0, ( char * )bf, bfSize, ( wchar_t * )ptb->buffer, size );

	return size != 0;
}

bool ConvertFromUTF8( cPlainTextBlock *ptb, const BYTE *bf, int bfSize )
{
	UINT codePage = CP_UTF8;

	int size = MultiByteToWideChar( codePage, 0, ( char * )bf, bfSize, NULL, 0 );

	if ( size == 0 )
	{
		// Windows 95 has no UTF-8 encoding, so we try ASCII
		return ConvertFromACP( ptb, bf, bfSize );
	}

	cPlainTextBlock utf8ptb;
	if ( utf8ptb.Allocate( size * sizeof( wchar_t ) ) == NULL )
		return false;

	size = MultiByteToWideChar( codePage, 0, ( char * )bf, bfSize, ( wchar_t * )utf8ptb.buffer, size );

	if ( size == 0 )
		return false;

	size = ptb->WriteBytes( utf8ptb.buffer, utf8ptb.bufferSize );

	return size == utf8ptb.bufferSize;
}

//bool ConvertToMBS( UINT codePage, cPlainTextBlock *ptb, const wchar_t *wcs, int wcsLen )
//{
//	int size = WideCharToMultiByte( codePage, 0, wcs, wcsLen, NULL, 0, NULL, NULL );
//
//	cPlainTextBlock utf8ptb;
//
//	if ( utf8ptb.Allocate( size ) == NULL )
//		return false;
//
//	size = WideCharToMultiByte( codePage, 0, wcs, wcsLen, (char*)utf8ptb.buffer, utf8ptb.bufferSize, NULL, NULL );
//
//	size = ptb->WriteBytes( utf8ptb.buffer, utf8ptb.bufferSize );
//
//	return size == utf8ptb.bufferSize;
//}

bool ConvertToMBS( UINT codePage, cPlainTextBlock *ptb, const wchar_t *wcs, int wcsLen )
{
	int len = WideCharToMultiByte( codePage, 0, wcs, wcsLen, NULL, 0, NULL, NULL );

	if ( len == 0 )
		return false;

	int pos = ptb->bufferSize;

	if ( ptb->ReAllocate( pos + len ) == NULL )
		return false;

	int res = WideCharToMultiByte( codePage, 0, wcs, wcsLen, (char *)(ptb->buffer + pos), len, NULL, NULL );

	if ( res != len )
		return false;

	ptb->bufferSize = pos + len;

	return true;
}

cStringBuffer::cStringBuffer( const wchar_t *szText, int len )
{
	m_skipEmptyString = true;
	//Init( bf, bfSize );

	if ( len == -1 )
		len = (int)wcslen( szText );

	m_startPos = 0;
	m_bf = ( BYTE * )szText;
	m_bfSize = len * sizeof ( wchar_t );
	
	m_isUnicode = true;

	if ( ( len >= 1 ) && ( szText[0] == 0xFEFF ) )
	{
		m_startPos +=2 ;
	}

	m_isUTF8 = false;

	Restart();
}

void cStringBuffer::Init( const BYTE *bf, SIZE_T bfSize )
{
	m_startPos = 0;
	m_bf = bf;
	m_bfSize = bfSize;
	
	m_isUnicode = false;
	m_isUTF8 = false;

	if ( m_bf == NULL )
		return;

	//
	//	Unicode little endian
	//
	if ( ( m_bf[0] == 0xFF ) && ( m_bf[1] == 0xFE ) )
	{
		//	Simple elliminates the unicode prefix 0xFF, 0xFE ( note, widechar symbol is 0xFEFF )in file beginning.
		m_isUnicode = true;
		m_startPos += 2;
	}
	else
	//
	//	Unicode big endian
	//
	if ( ( m_bf[0] == 0xFE ) && ( m_bf[1] == 0xFF ) )
	{
		//	Converts to little endian ( wide char ).
		cPlainTextBlock ptb;
		ConvertFromBigEndian( &ptb, m_bf + 2, (int)m_bfSize - 2 );
		SetBuffer( &ptb );
		m_isUnicode = true;
	}
	else
	//
	// UTF-8
	//	EF BB BF
	//
	if ( ( m_bf[0] == 0xEF ) && ( m_bf[1] == 0xBB ) && ( m_bf[2] ==0xBF ) )
	{
		//	Converts to little endian ( wide char ).
//		cPlainTextBlock ptb;
//		ConvertFromUTF8( &ptb, m_bf + 3, m_bfSize - 3 );
//		SetBuffer( &ptb );
		m_isUnicode = true;
		m_isUTF8 = true;
		m_startPos += 3;
	}
	else
	if ( ( m_bf[0] == 0 ) || ( m_bf[1] == 0 ) )
	{
		m_isUnicode = true;
	}
	else
	{
		// m_isUnicode = false;

		////	Converts to little endian ( wide char ).
		//cPlainTextBlock ptb;
		//ConvertFromACP( &ptb, m_bf, m_bfSize );
		//SetBuffer( &ptb );
		//m_isUnicode = true;
	}

	Restart();
}

bool cStringBuffer::ReadString( char *buff, int buffSize )
{
	if ( m_isUnicode )
	{
		wchar_t *wcs = new wchar_t[ buffSize ];
	
		if ( wcs == NULL )
			return false;

		bool ok = ReadStringW( wcs, buffSize );

		if ( ok )
			WideCharToMultiByte( CP_ACP, 0, wcs, buffSize, buff, buffSize, NULL, NULL );

		delete wcs;

		return ok;
	}

	return ReadStringA( buff, buffSize );
}

bool cStringBuffer::ReadStringW( wchar_t *buff, int buffSize )
{
	if ( m_isUTF8 )
	{
		int utf8Size = buffSize * 5;

		char *mbs = new char[ utf8Size ];
	
		if ( mbs == NULL )
			return false;

		bool ok = ReadStringA( mbs, utf8Size );

		if ( ok )
			MultiByteToWideChar( CP_UTF8, 0, mbs, utf8Size, buff, buffSize );

		delete mbs;

		return ok;
	}

	return readString( this, buff, buffSize, &m_bCompleted );

	////ODSFuncS( _FormatT( L"%X, %d", buff, buffSize ) );

	////if ( m_pos >= m_bfSize )
	////	return false;

	//int i;

	//for( i = 0; ; i++ )
	//{

	//	if ( i >= buffSize )
	//	{
	//		buff[ buffSize - 1 ] = L'\0';
	//		break;
	//	}

	//	//
	//	// 20.02.2010
	//	//
	//	if ( m_pos >= m_bfSize )
	//	{
	//		if ( i == 0 )
	//			return false;

	//		//
	//		//	22.02.2010
	//		//	Last string is not terminated by \r\n is valid.
	//		//
	//		buff[ i ] = L'\0';
	//		return true;
	//	}

	//	wchar_t ch = *( wchar_t *) ( m_bf + m_pos );

	//	//
	//	//	20.02.2010
	//	//
	//	if ( ch == 0 )
	//	{
	//		ODS_fls( L"Assertion: zero character is detected" );
	//		//return false;
	//	}

	//	if ( ( ch == L'\r' ) || ( ch == L'\n' ) )
	//	{
	//		buff[ i ] = L'\0';

	//		if ( !m_skipEmptyString )
	//		{
	//			if ( wcsncmp( (wchar_t *)(m_bf + m_pos), L"\r\n", 2 ) == 0 )
	//				m_pos += 4;
	//			else
	//				m_pos += 2;
	//		}
	//		else
	//		{
	//			// Skips all \r \n symbols for next string
	//			do
	//			{
	//				if ( m_pos >= m_bfSize )
	//					break;
	//				else
	//				{
	//					m_pos += 2;
	//					if ( m_pos >= m_bfSize )
	//						break;
	//				}

	//				ch = *( wchar_t *) ( m_bf + m_pos );
	//			}
	//			while( ( ch == L'\r' ) || ( ch == L'\n' ) );
	//		}

	//		break;
	//	}
	//	else
	//	{
	//		buff[ i ] = ch;
	//		if ( m_pos >= m_bfSize )
	//		{
	//			if ( i < buffSize - 1 )
	//				i++;
	//			buff[ i ] = L'\0';
	//			break;
	//		}
	//		else
	//			m_pos += 2;
	//	}
	//}

	////ODSFuncRes( buff );

	//return true;
}

bool cStringBuffer::ReadStringT( wchar_t *buff, int buffSize )
{
	if ( m_isUnicode )
		return ReadStringW( buff, buffSize );

	cPlainTextBlock ptb;
	
	if ( ptb.Allocate( buffSize * 4 ) == NULL )
		return false;

	if ( !ReadString( (char *)ptb.buffer, ptb.bufferSize ) )
		return false;

	size_t num = 0;
	mbstowcs_s( &num, buff, buffSize, (char *)ptb.buffer, _TRUNCATE ); 

	return true;
}

bool cStringBuffer::FindString( wchar_t *buff, int buffLen, const wchar_t *str, bool getTailOnly )
{
	//
	// 05.02.2015
	//	It saves current position.
	//
	cSaveValue < SIZE_T >  sv( &m_pos );

	Restart();

	int len = (int)wcslen( str );

	wchar_t bf[ 2048 ];

	while( ReadStringT( bf, maxLen( bf ) ) )
	{
		if ( wcsncmp( bf, str, len ) == 0 )
		{
			if ( ( buff == NULL ) || ( buffLen == 0 ) )
				return true;

			int size = (int)wcslen( bf ) + 1;

			if ( getTailOnly )
			{
				wcsncpy_s( buff, buffLen, bf + len, _TRUNCATE );
			}
			else
			{
				wcsncpy_s( buff, buffLen, bf, _TRUNCATE );
			}

			return true;
		}
	}

	if ( ( buff != NULL ) && ( buffLen > 0 ) )
		buff[0] = L'\0';

	return false;
}

// Profiles functions
//	[Section]
//	Value = 'Data'
bool cStringBuffer::GetProfileStringT( wchar_t *outBuff, int *pBuffLen, const wchar_t *section, const wchar_t *value )
{
	//
	// 05.02.2015
	//	It saves current position.
	//
	cSaveValue < SIZE_T > sv( &m_pos );

	Restart();

	int len = (int)wcslen( section );

	wchar_t bf[ 2048 ];
	int bfLen;

	// Finds section.
	while( true )
	{
		if ( !ReadStringT( bf, maxLen( bf ) ) )
			return false;

		if ( bf[0] != L'[' )
			continue;

		bfLen = (int)wcslen( bf );

		if ( ( bfLen < 1 + len + 1 ) ||
			 ( wcsncmp( bf + 1, section, len ) != 0 ) ||
			 ( bf[ 1 + len ] != L']' ) )
				continue;

		break;
	}

	// Finds value strinig.

	len = (int)wcslen( value );

	while( true )
	{
		if ( !ReadStringT( bf, maxLen( bf ) ) )
			return false;

		if ( bf[0] == L'[' ) // Next section found.
			return false;

		bfLen = (int)wcslen( bf );

		if ( wcsncmp( bf, value, len ) != 0 )
			continue;

		break;
	}

	// Parses value string.
	// value    =    data
	while( bf[len] == L' ' ) len++;
	if ( bf[len++] != L'=' ) return false;
	while( bf[len] == L' ' ) len++;

	bool err = ( *pBuffLen < bfLen - len + 1 );

	*pBuffLen = bfLen - len + 1;

	if ( err )
		return false;

	wcsncpy_s( outBuff, *pBuffLen, bf + len, _TRUNCATE );

	return true;
}

static wchar_t hex2wc( BYTE hex )
{
	hex &= 0x0F;

	if ( hex >= 10 )
		return L'A' + ( hex - 10 );

	return L'0' + hex;
}

static wchar_t *byte2hex( wchar_t *hexStr, const BYTE byte, const wchar_t cLast = L' ' )
{
	hexStr[0] = hex2wc( ( byte >> 4 ) );
	hexStr[1] = hex2wc( ( byte ) );
	hexStr[2] = cLast;
	hexStr[3] = L'\0';

	return hexStr;
}

static bool hex2byte( BYTE *pByte, const wchar_t *hexStr )
{
	*pByte = 0;
	for( int i = 0; i<2; i++ )
	{
		BYTE bt;
		wchar_t h = hexStr[i];

		if ( ( h >= L'0' ) && ( h <= L'9' ) )
			bt = h - L'0';
		else
		if ( ( h >= L'A' ) && ( h <= L'F' ) )
			bt = h - L'A' + 10;
		else
		if ( ( h >= L'a' ) && ( h <= L'f' ) )
			bt = h - L'a' + 10;
		else
			return false;

		*pByte = ( *pByte << 4 ) | bt ;
	}

	return true;
}

//
//	If success Returns size of parsed bytes
//	Otherwise returns -1
//
int string2bytes( BYTE *bf, int bfSize, const wchar_t *str )
{
	int len = (int)wcslen( str );
	int pos = 0;

	for( int i = 0; i < len; i++ )
	{
		wchar_t ch = str[i];
		if ( ch == L' ' )
			continue;

		if ( i + 1 > len )
			return pos;

		BYTE bt;
		if ( !hex2byte( &bt, str + i++ ) )
			return pos;

		if ( ( bf != NULL ) && ( bfSize > pos ) )
			bf[pos] = bt;

		pos++;
	}

	return pos;
}

int bytes2string( wchar_t *str, int strSize, BYTE *bf, int bfSize, const wchar_t cSeparator )
{
	int len = 0;
	int pos = 0;
	
	wchar_t szSeparator[2] = L" "; 
	if ( cSeparator == 0 )
		szSeparator[0] = '\0';
	else
		szSeparator[0] = cSeparator;

	for(; pos < bfSize; pos++ )
	{
		if ( len + 3 > strSize )
			break;

#ifdef _UnicodeFuncs_
		FormatT( str + len, strSize - len, L"%02X%s", (DWORD)bf[pos] & 0xFF, szSeparator );
#else
		wchar_t wcs[4]; // 4 wide char 'FF '
		byte2hex( wcs, bf[pos], szSeparator[0] );
		wcscpy_s( str + len, strSize - len, wcs );
#endif
		int addLen = (int)wcslen( str + len );
		len += addLen;
	}

	return pos;
}

#endif // #ifdef _WIN32
