#ifndef _cSysDll_
#define _cSysDll_

#include "CDll.h"
#include <shlwapi.h>

class CSysDll : public CDll
{
public:
	DLLVERSIONINFO version;

	// Default constructor means calling of Load or LoadOnce functions

	CSysDll()
	{
		memset( &version, 0, sizeof( version ) );
	}

	CSysDll( BOOL usePath , const char *libraryName, const char *procName = NULL, BOOL showMessage = false )
	{
		memset( &version, 0, sizeof( version ) );
		Load( usePath, libraryName, procName, showMessage );
	}
	
	virtual bool LoadOnce( BOOL usePath , const char *libraryName, BOOL showMessage = TRUE )
	{
		if ( hInst != NULL )
			return true;

		return Load( usePath , libraryName, NULL, showMessage );
	}

	//virtual 
	bool Load( BOOL usePath , const char *libraryName, const char *procName = NULL, BOOL showMessage = false )
	{
		if ( !CDll::Load( usePath, libraryName, procName, showMessage ) )
			return false;

		typedef HRESULT CALLBACK typeDllGetVersion( DLLVERSIONINFO *pdvi );
		
		typeDllGetVersion *getVerProc = (typeDllGetVersion *)::GetProcAddress( hInst, "DllGetVersion" );

		memset( &version, 0, sizeof( version ) );
		version.cbSize = sizeof( version );

		if ( getVerProc == 0 )
		{
			error = 2;
			return false;
		}

		getVerProc( &version );

		return true;
	}
};
	
#endif // _cSysDll_