////////////////////////////////////////////////////////////////
//
//	processorTypes
//		1. gets type of processor in current system.
//		2. gets the machive type of the executable file it has been designed.
//		3. checks file machine type and system processor type compatibility.
//		4. gets quantity of processors available for current process.
//

#pragma once

#include <windows.h>

#ifndef PROCESSOR_AMD_X8664
#define PROCESSOR_AMD_X8664 8664
#endif

#ifndef PROCESSOR_INTEL_IA64
#define PROCESSOR_INTEL_IA64    2200
#endif

//
//	PT_getFileMachineType
//		Reads file headers and gets Machine type from ImageFileHeader.
//		Returns file machine type if success. Otherwise returns zero.
//
WORD PT_getFileMachineType( HANDLE hImage );
WORD PT_getFileMachineType( const char *fileName );

//
//	PT_getSystemProcessorType
//
DWORD PT_getSystemProcessorType( WORD *pArchitecture = NULL );

//
//	PT_checkCompatibility
//		Returns true if executable file is compatible with processor
//
bool PT_checkCompatibility( DWORD dwProcessorType, WORD wImageFileHeaderMachine );

//
//	PT_getProcessorCount
//		Returns quantity of processors available for current process.
//
int PT_getProcessorCount();
