#pragma once
#include <windows.h>
#include "..\CertificateLib\SMemory\SBlocks.h"

#pragma pack(1)

//
//	class cRegDlgValues
//
//		Parent class for storing dialog information
//		the parent saves/restore the dlg position and list view columns only
//		Child subclass may assign it's own values before saving and read the values after restoring.
//
class cRegDlgValues
{
public:
	int  m_size;	// real size of the class with subclasses
	RECT m_rect;	// dlg position
	int  m_colQ;	// list view column quantity
	int* m_colT;  // list vliew column width table
	wchar_t *m_valueName; // Name of the value to be stored at regisry.
	DWORD m_lvType; // list view type
	HKEY m_hRoot;
	wchar_t *m_keyName;

	cRegDlgValues()
	{
		m_hRoot = 0;
		m_keyName = NULL;
	};

	cRegDlgValues( HKEY hRoot, const char *keyName, const char *valueName, int totalSubClassSize, int columns = 0 );
	cRegDlgValues( HKEY hRoot, const wchar_t *keyName, const wchar_t *valueName, int totalSubClassSize = sizeof( cRegDlgValues ), int columns = 0 );
	void Init( HKEY hRoot, const wchar_t *keyName, const wchar_t *valueName, int totalSubClassSize, int columns = 0 );
	void InitColumns( int columns = 0, int lvType = 0 );
	~cRegDlgValues();

	bool Restore( HWND hDlg = NULL, HWND hList = NULL, BYTE *buff = NULL , int buffSize = 0, DWORD spFlags = 0 );
	bool Save( HWND dlg, HWND listView = NULL, BYTE *buff = NULL , int buffSize = 0 );
	bool Save( BYTE *buff = NULL, int buffSize = 0 );
};

#pragma pack()

// Encrypted read and write registry functions.

bool readFromRegistry( cPlainTextBlock *ptb, HKEY hRegRoot, const wchar_t *regKeyName, const wchar_t *valueName );
bool writeToRegistry( cPlainTextBlock *ptb, HKEY hRegRoot, const wchar_t *regKeyName, const wchar_t *valueName  );


