#pragma once

#include "unicodeFuncs.h"
#include "ODS.h"

class cWalkFiles
{
public:

	bool m_ok;
	bool m_useSubdirectories;

#ifdef _ODS
	cWCStr m_odsName;
#endif
	
	cWalkFiles( const wchar_t *odsName = NULL )
	{
#ifdef _ODS
		if ( odsName )
			m_odsName.Set( odsName );
#endif
		m_useSubdirectories = true;
		m_ok = true;
	}

	~cWalkFiles()
	{
		//ODSFuncS( m_odsName.m_szBody );
	}

	virtual bool Actor( const wchar_t *path )						{ return false; }
	virtual bool Actor( const wchar_t *path, WIN32_FIND_DATAW *pfd ){ return Actor( path ); }

	int Walk( const wchar_t *dir, const wchar_t *pattern = L"*" )
	{
		//ODSFuncS( cWCStr().FormatT( L"%s, %s", dir, m_odsName.m_szBody ) );

		wchar_t path[ MAX_PATH * 2 ];
		wcscpy_s( path, maxLen( path ), dir );
		int pos = (int)wcslen( path );

		if ( pos == 0 )
			return 0;

		if ( path[ pos - 1 ] != L'\\' )
			path[ pos++ ] = L'\\';

		wcscpy_s( path + pos, maxLen( path ) - pos, pattern );

		WIN32_FIND_DATAW fd;

		HANDLE hFind = FindFirstFileT( path, &fd );

		int count = 0;

		if ( hFind != INVALID_HANDLE_VALUE )
		{
			do
			{
				wcscpy_s( path + pos, maxLen( path ) - pos, fd.cFileName );

				if ( ( fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) != 0 )
				{
					if ( ( wcscmp( fd.cFileName, L"." ) == 0 ) || 
						 ( wcscmp( fd.cFileName, L".." ) == 0 ) )
							continue;

					if ( m_useSubdirectories )
						count += Walk( path, pattern );
					else
						m_ok = Actor( path, &fd );
				}
				else
					m_ok = Actor( path, &fd );

				if ( !m_ok )
					break;

				count ++;
			}
			while( FindNextFileT( hFind, &fd ) );

			FindClose( hFind );
		}

		//ODSFuncRes( count );

		return count;
	}
};

