/*******************************************************************
 *
 *	Copyright (c) 1994-2007 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File: hdlg.cpp
 *	Revision: 
 *	Created:
 *	Description: implementation of procedures that support 
 *		dialog boxes for creating hidden part of containers 
 *		and showing an information message.
 *
 *******************************************************************/

#include <windows.h>
#include "..\..\comm_def\kg_errors.h"
#include "resource.h"
#include "cDlg.h"
#include "KgGhost.h"

BOOL CALLBACK showInfoMsgDlgProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	if (uMsg == WM_INITDIALOG)
	{
		if ( !appFlags.GetFlag( efShowHPInfo ) )
		{
			EndDialog( hwnd, ERROR_NO );
			return false;
		}
		Button_SetCheck( GetDlgItem( hwnd, IDC_chkShow ), BST_CHECKED );
		return TRUE; 
	}
	else if (uMsg == WM_COMMAND )
	{
		WORD cmd = LOWORD( wParam );
		if ( cmd == IDOK )
		{
			bool show = ( Button_GetCheck( GetDlgItem( hwnd, IDC_chkShow ) ) == BST_CHECKED );
			appFlags.SetFlag( efShowHPInfo, show );

			EndDialog(hwnd, ERROR_NO);
			return FALSE;
		}
	}

	return FALSE;
}

void HDLG_ShowInformationMessage( HINSTANCE hInst, HWND hWnd )
{
	cDlg dlg;
	dlg.DoModal( hInst, IDD_HP_INFO_DIALOG, hWnd, (DLGPROC)showInfoMsgDlgProc );
}
