/*******************************************************************
 *
 *	Copyright (c) 1994-2013 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File: pwdlg.h
 *	Revision: 
 *	Created:
 *	Description: declaration of procedures that support 
 *		dialog boxes for accepting user's password and 
 *		dialog that supports generation of seed value for 
 *		random key generation
 *
 *******************************************************************/

#pragma once

#include <windows.h>
class cPassword;
#include "cKeyFileList.h"
#include "kgParams.h"

extern DWORD GetPassword( 
		HWND   hWnd,
		const wchar_t *text,
		const wchar_t *caption,
		cPassword *pwd,
		cKeyFileList *keyFileList,
		DWORD  *pFlags = NULL,
		sCKHParams *ps = NULL, //wchar_t *mountPoint = NULL
		cWCS *wcsKbb = NULL
	);

class cKeyBlockParams;

//extern DWORD GetKeyBlockParamsWithVerification_Advanced(
//		HWND   hWndParent,
//		const wchar_t *text,
//		const wchar_t *caption,
//		cKeyBlockParams *kbParams,
//		DWORD  *pFlags,
//		DWORD maxFreeSize,
//		bool simple = false // Use dialog with two edits and advanced button only
//	);

extern DWORD GetKeyBlockParamsWithVerification(
		dbHeaderBase &header,
		HWND hWnd,
		const wchar_t	*text,
		const wchar_t	*caption,
		cKeyBlockParams *kbParams,
		DWORD *pFlags,
		DWORD maxFreeSize = -1, //  -1 means max available
		//
		//	Damaged data block uses simple mode only.
		//	The flag is true for change password only where we have no key map for damaged block.
		//	We know current key size and position only and will overwrite this position.
		//	To prevent overwriting more slots we restrict simple mode dialog with PBE minimal size slot.
		//
		bool bDataBlockIsDamaged = false
	);

extern bool bCmdLinePassword;


//
//	GetKeyBlockParams
//		Uses GetPassword to fills kbPBE.m_pwd buffers only.
//
extern DWORD GetKeyBlockParams(
		HWND hWnd,
		const wchar_t	*text,
		const wchar_t	*caption,
		cKeyBlockParams *kbParams,
		DWORD *pFlags,
		sCKHParams *ps = NULL, 		//wchar_t *mountPoint = NULL
		cWCS *wcsKbb = NULL
	);

extern DWORD GetAdvancedFlags( 
			DWORD *Flags,
			HWND  hWndParent
			);

//
//	GetPasswordFromCommandLine
//		Reads password from command line, see GetKeyBlockParamsWithVerification and GetPassword functions.
//		The seed generation function uses the password for seed buffer generation, see GetSeedValue.
//		Note! It is not secure to pass password as command line.
//
extern bool	GetPasswordFromCommandLine(
			wchar_t *Password,	// buffer size is 256 symbols
			DWORD *pFlags,
			cKeyFileList *keyFileList = NULL
	);
