/*******************************************************************\
 *
 *	Copyright (c) 2015 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File:        cDlgKeyFileMan.h
 *	Revision:  
 *	Created:     02-March-2015
 *  Author:      A. Pichuev
 *	Description: Dialog shows current list if key files and allows to modify it. 
 *
\*******************************************************************/

#pragma once

#include "..\..\..\Includes\cDlg.h"
#include "..\..\..\Includes\ptbRegs.h"
#include "..\..\..\Includes\IconCache.h"
#include "..\..\..\Includes\cDropTarget.h"
#include "resource.h"
#include "cKeyFileList.h"


class cDlgKeyFileMan : public cDlgBase, public cDropTarget
{
	cKeyFileList &m_keyFileList;	// Is updated from m_keyFileList if OK button is pressed

	cRegDlgValues m_ptbVals;
	int m_filesQ;
	cWCStr m_pattern;
	HWND m_hList;
	cIconCache *m_iconCache;
	cDropTarget *m_iDropTarget;

public:
	
	cDlgKeyFileMan( cKeyFileList &keyFileList );

	virtual bool InitDialog();
	virtual bool OnDestroy();
	virtual LONG_PTR OnNotify( NMHDR *pnmh );
	virtual HRESULT Drop( cFilesList &ofl );

	virtual bool OnCommand( WORD ctrlId, HWND hCtrl = 0, WORD isAccelerator = 0 );

	bool OnAddFiles();
	bool OnAddFolders();
	bool OnRemoveSelected();
	bool OnRemoveAll();

	void fillListView();
	bool saveListView();
	void checkButtonStates();
	bool initDropTarget();

	bool addPath( const wchar_t *path );
};