/*******************************************************************\
*
*	Copyright (c) 2015 Jetico, Inc., Finland
*	All rights reserved.
*
*	File: cKeyFileList.h
*	Revision: 
*	Created:		02.03.2015
*	Description:	Class with list of key files.
*
\*******************************************************************/

#pragma once

#include "..\..\..\Includes\UnicodeFuncs.h"
#include "..\..\..\Includes\cStringArray.h"
#include "..\..\..\Includes\cFindFile.h"
//#include "resource.h"

class cProcessPath
{
public:
	//
	// actor abstract virtual function.
	//	if success	returns number of procesed files,
	//	if error	retruns -1 
	//
	virtual int actor( const wchar_t *path ) = 0;

	DWORD m_sysErr;
	virtual void showError(  const wchar_t *path )
	{
		//if ( m_sysErr != NULL )
		//{
		//	cWCStr wcs;
		//	wcs.GetSystemError( m_sysErr );
		//	wcs.AddF( L"\n%s: %s", _LoadIDS( IDS_szPath ), path );
		//	MessageBoxT( IH.getMainWnd(), wcs.m_szBody, _LoadIDS( IDS_ERROR ), MB_ICONSTOP );
		//}
	}
};

class cKeyFileList
{
	cWCStr m_pattern;
	cPTB m_ptbSalt;
public:
	cStringArrayT m_sa;

	cKeyFileList()
	{
	}

	BYTE *getSaltBuffer()	{ return m_ptbSalt.buffer;		}
	int	  getSaltSize()		{ return m_ptbSalt.bufferSize;	}

	bool generateSaltBuffer( int hashAlgId, BYTE *saltBuffer, int saltSize );

	static int processPath( const wchar_t *path, cProcessPath *process = NULL );
	int processPathes( cProcessPath *process = NULL );

	//
	//	getFileQ
	//		returns 1 if path is file, otherwise number of files in the directory
	//
	static int getFileQ( const wchar_t *path, DWORDLONG *psize = NULL );
	int getFileQ( DWORDLONG *psize = NULL );
	bool hasFiles()
	{
		return getFileQ() != 0;
	}

	//
	//	makeFileDigest
	//		Opens file, 
	//		reads upto tail but not more than 1M, 
	//		returns system error.
	//
	static int makeFileDigest( int hashAlgId, BYTE *digest, const wchar_t *path, DWORD maxSize = 1024 * 1024 );

	bool fillHashTable( cPTB &ptbHashes, int hashAlgId );
	
	int updateWindowText( HWND hWnd );

	void Clear()
	{
		m_sa.freeTable();
	}

	//
	//	Set
	//		Copies from parameters.
	//
	bool Set( cKeyFileList &kfl )
	{
		m_sa.copyFrom( &kfl.m_sa, false );
		return true;
	}
};