/*******************************************************************
 *
 *	Copyright (c) 1994-1998 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File: pwdlg.h
 *	Revision: 
 *	Created:
 *	Description: declaration of procedures that support 
 *		dialog boxes for accepting user's password and 
 *		dialog that supports generation of seed value for 
 *		random key generation
 *
 *******************************************************************/


#ifndef __PWDLG
#define __PWDLG

#include <windows.h>

extern DWORD GetPassword( 
				HWND   hWndParent,
				const wchar_t *text,	// Some information Text, for example - filename of the container
				const wchar_t *caption,	// Caption of the "get password" dialog window
				char   *password,
				DWORD  *Flags,
				DWORD  *FavoriteDrive,
				BOOL   ContainsFileName = TRUE
				);

extern DWORD GetPasswordWithVerification(
				HWND   hWndParent,
				const wchar_t *text,	// Some information Text, for example - filename of the container
				const wchar_t *caption,	// Caption of the "get password" dialog window
				char   *password,
				DWORD  *Flags
				);

//extern DWORD GetSeedValue( 
//			HWND  hWndParent,
//			BYTE  *seed, 
//			DWORD seedLength
//			);


extern DWORD GetAdvancedFlags( 
			DWORD *Flags,
			HWND  hWndParent
			);


#endif /* __PWDLG */
