#include <windows.h>
#include <string.h>
#include <io.h>
#include "GetBCPath.h"
#include "..\..\Includes\UnicodeFuncs.h"
//#include "Funcs.h"
#include "commonFuncs.h"

static const wchar_t *szUninstallSection = L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\";

//
//	BCApps' names
//
const wchar_t *szBCArchive	= L"BCArchive";
const wchar_t *szBCWipe		= L"BCWipe";
const wchar_t *szBestCrypt	= L"BestCrypt";
const wchar_t *szBCWipeTWO	= L"BCWipeTWO";
const wchar_t *szBCWipePD	= L"BCWipePD";

#ifndef KEY_WOW64_32KEY
#define KEY_WOW64_32KEY 0x200
#define KEY_WOW64_64KEY 0x100
#endif

bool GetBCHomeDir( wchar_t *bcdir, const wchar_t *appName )
{
	wchar_t buff[ MAX_PATH * 2 ];
	wchar_t *value = buff;

	if ( !GetUninstallString( appName, value ) )
		return false;

	// Code from getInstalledPath procedure.
	// Find and extract Uninstall file name...

	value++; // Take next from first '\"'

	while( *value != L'\"' )
	{
		if ( *(value++) == 0 )
			return FALSE;
	}
	
	if ( *(++value) != L' ' )
		return FALSE;

	value++;

	if ( !FileExistsT( value ) )
		return false;

	bool res = GetShortPathNameT( value, buff, maxLen( buff ) ) != 0;

	int fileNamePos = splitPath( buff );
	buff[ fileNamePos ] = L'\0';

	if ( bcdir != NULL )
		copyString( bcdir, buff, MAX_PATH );

	return true;
}

//
//	GetBCHomeDir
//	Gets short name of corresponded home folder
//	We need get valid BestCrypt.exe name ( instead of short name BESTCR~1.EXE ) for manifest file proper 
//	working ( Windows XP )
//
bool GetBCHomeDir( wchar_t *bcdir, bool bcrypt )
{
	return GetBCHomeDir( bcdir, ( bcrypt ? szBestCrypt : szBCWipe ) );
}

