/////////////////////////////////////////////////////////////////////////////////////
//
//      Copyright (c) 2017 Jetico Inc. Oy, Finland
//      All rights reserved.
//
//      File: camellia.h
//      Revision:
//      Created:	22.07.2017
//      Description:
//            RFC 3713: "Camellia Encryption Algorithm", April 2004
//      Implementation:
//            Calculations are based on 64bit limbs ( effective for 64bit system )
//
/////////////////////////////////////////////////////////////////////////////////////

#ifndef __BC_CAMELLIA
#define __BC_CAMELLIA

#include "intsize.h"
#include "camellia.h"

#define SERVICE_NAME          "bc_camellia"
#define DISPLAY_NAME          "CAMELLIA-256"
#define ALGORITHM_ID           0xCA // 202

#define ALGORITHM_BLOCK_SIZE_BYTES CAMELLIA_BLOCK_SIZE

// Key length in bits
#define KEY_LENGTH          (256)
#define KEY_LENGTH_EXTENDED (CAMELLIA_TABLE_BYTE_LEN * 8)


#define DRIVER_MAJOR_VERSION	1
#define DRIVER_MINOR_VERSION	0


/******* Exported functions *********/

#define IN

BOOL
KeyExtend( PUCHAR KeySource,          // KEY_LENGTH bits
           PDWORD KeyDestination );   // KEY_LENGTH_EXTENDED bits

VOID
Encrypt( DWORD *IVector, 
         DWORD *KeyAdress,
         DWORD *SrcBuffer,
         DWORD *DstBuffer,
         DWORD Length );    // in bytes

VOID
Decrypt( DWORD *IVector, 
         DWORD *KeyAdress,
         DWORD *SrcBuffer,
         DWORD *DstBuffer,
         DWORD Length );    // in bytes

void Encrypt_ECB( BYTE  *Input,        /* 16 bytes of input data              */
                  BYTE  *Output,       /* 16 bytes of output data             */
                  BYTE  *ExtendedKey); 


void Decrypt_ECB( BYTE  *Input,        /* 16 bytes of input data              */
                  BYTE  *Output,       /* 16 bytes of output data             */
                  BYTE  *ExtendedKey);



#endif // __BC_CAMELLIA

