////////////////////////////////////////////////////////////////////////////////////
//
//	Copyright (c) 2004 Jetico, Inc., Finland
//	All rights reserved.
//
//	File: kbdEdit.h
//	Revision: 
//	Created:
//	Description: 
//		Edit box sub class, it work with key board filter functions ( see kbd.h )
//
////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include <windows.h>
#include "..\..\COMM_DEF\kbd.h"
#include "..\..\..\CertificateLib\SMemory\cPassword.h"

class cDlgKBParams;
//class cPassword;

#define BUFFER_SIZE 1024

enum { eOk = 0, eLongPwd };

#define WM_BufferIsUpdated			( WM_USER + 1 )
#define WM_USER_INPUTLANGCHANGE		( WM_USER + 2 )
#define WM_USER_CHECK_FOCUS			( WM_USER + 3 )

class cKbdEdit
{
public:
#ifdef _DEBUG
	enum { sidData = 0xBC2007 };
	DWORD m_sig;
#endif

	wchar_t m_buffer[ BUFFER_SIZE ];
	HWND m_hEdit;
	int m_setQ;

	//
	// Kill focus problem. See Attach and 'Check focus strategy'.
	//
	HWND m_hEditPost;
	HWND m_hLine;
	HANDLE m_hThread;

	LONG_PTR m_origWndProc;

	bool m_bMhkHasDetectedKey;
	void UpdateSecureTypingView( bool bUseSecureTyping, bool bMhkHasDetectedKey );

	cDlgKBParams *dlg;
	kbdParams *kbd;

	void ClearBuff()
	{
		Empty();
		m_origWndProc = NULL;
		m_bMhkHasDetectedKey = false;
	}

	void Empty()
	{
		memset( m_buffer, 0, sizeof( m_buffer ) );
		memset( m_rndBuffer, 0, sizeof( m_rndBuffer ) );
		SetWindowTextT( m_hEdit, L"" );
	}

	cKbdEdit()
	{
#ifdef _DEBUG
		m_sig = sidData;
#endif

		m_hEdit = NULL;
		m_hEditPost = NULL;
		m_hThread = NULL;
		m_setQ = 0;
		 
		ClearBuff();
	}

	~cKbdEdit()
	{
		ClearBuff();
	}

	bool Attach( HWND hEdit, HWND hSecureTypesLine = NULL );
	void Detach();

	//
	//	Task #3054	Changing content in Anti-keylogger settings window
	//		Requires to show random but we did not save wthe random specially, it is shown at edit box only, but only if password is not shown
	//		At testing the password edit box shows valid latter so we have to save the useless random at special buffer.
	//		Note the m_rndBuffer is required for the feature only.
	//
	wchar_t m_rndBuffer[ BUFFER_SIZE ];

	int InsertCharToBufferW(
			wchar_t Letter,
			bool IsLetter = true,
			wchar_t letterShow = 0,
			wchar_t wRnd = 0 // Is added by Task #3054
		);

	int InsertCharToBuffer( char Letter, bool IsLetter = true );

	//
	//	addSymbols
	//		return number of added sumbols.
	//
	int addSymbols( const wchar_t *wcs, bool bShowChartacters = true, bool bAppend = true, bool bUseSecureTyping = true );

	static LRESULT APIENTRY editProc( HWND hEdit, UINT uMsg, WPARAM wParam, LPARAM lParam )
	{
		cKbdEdit *edit = (cKbdEdit *)(LPARAM)GetWindowLongPtrT( hEdit, GWLP_USERDATA );
		if ( edit == NULL )
		{
			assert( false );
			return false;
		}

		return edit->realEditProc( uMsg, wParam, lParam );
	}

	bool setEncodeTable( cDlgKBParams *dlg, HWND hDlg );

	virtual LRESULT realEditProc( UINT uMsg, WPARAM wParam, LPARAM lParam );

	static bool CheckAndGetPassword( cPassword *pwd, cKbdEdit *edtA, cKbdEdit *edtB, bool silent = false );
	static bool CheckAndGetPassword( cPassword *pwd, cKbdEdit *edt, bool silent = false );
};

extern bool bDelayFiltering;
